<!--
###############################################################################
# The code below is released to public domain, you can do whatever you want
# with it and there is no need to refer to me as the original author.
#
# However, if you find it useful, I will be happy if you let me know :-)!
# Any comments to the code are also welcome. Especially if you find a bug
# or something which can be improved, I will be very happy to hear about it.
# You can contact me at papacut@kosmishmish.com.
#
# The code and the whole package is provided as it is, you acknowledge that it 
# can contain bugs. The author is neither responsible for any damage or loss,
# whether direct, consequential, incidental, or special which user suffers
# arising from any defect, error or fault of the application or its failure to
# perform, even if author has been advised of the possibility of such defect,
# error, fault, or failure. In any event, author's total aggregate liability
# to you for all damages of every kind and type (regardless of whether based in
# contract or tort) shall not exceed $0.00. In the case that applicable law may
# not allow the limitation or exclusion of liability or incidental or
# consequential damages, the above limitation or exclusion may not apply to
# you, although author's liability will be limited to the fullest extent
# permitted by applicable law. 
###############################################################################
-->

<html>
    <body>
<?php
        require_once('setup_login.php');
        require_once('debug_support.php');

        function pearsonHash($input_string) {
          $f_transposition = array(
            1, 87, 49, 12, 176, 178, 102, 166, 121, 193, 6, 84, 249, 230, 44, 163,
            14, 197, 213, 181, 161, 85, 218, 80, 64, 239, 24, 226, 236, 142, 38, 200,
            110, 177, 104, 103, 141, 253, 255, 50, 77, 101, 81, 18, 45, 96, 31, 222,
            25, 107, 190, 70, 86, 237, 240, 34, 72, 242, 20, 214, 244, 227, 149, 235,
            97, 234, 57, 22, 60, 250, 82, 175, 208, 5, 127, 199, 111, 62, 135, 248,
            174, 169, 211, 58, 66, 154, 106, 195, 245, 171, 17, 187, 182, 179, 0, 243,
            132, 56, 148, 75, 128, 133, 158, 100, 130, 126, 91, 13, 153, 246, 216, 219,
            119, 68, 223, 78, 83, 88, 201, 99, 122, 11, 92, 32, 136, 114, 52, 10,
            138, 30, 48, 183, 156, 35, 61, 26, 143, 74, 251, 94, 129, 162, 63, 152,
            170, 7, 115, 167, 241, 206, 3, 150, 55, 59, 151, 220, 90, 53, 23, 131,
            125, 173, 15, 238, 79, 95, 89, 16, 105, 137, 225, 224, 217, 160, 37, 123,
            118, 73, 2, 157, 46, 116, 9, 145, 134, 228, 207, 212, 202, 215, 69, 229,
            27, 188, 67, 124, 168, 252, 42, 4, 29, 108, 21, 247, 19, 205, 39, 203,
            233, 40, 186, 147, 198, 192, 155, 33, 164, 191, 98, 204, 165, 180, 117, 76,
            140, 36, 210, 172, 41, 54, 159, 8, 185, 232, 113, 196, 231, 47, 146, 120,
            51, 65, 28, 144, 254, 221, 93, 189, 194, 139, 112, 43, 71, 109, 184, 209);
      
          $curr_hash = 0;
          for ($index = 0; $index < strlen($input_string); $index++) {
            $curr_char = $input_string[$index];
            $curr_hash = $f_transposition[$curr_hash ^ ord($curr_char)];
          }
          return $curr_hash;
        }

        $dbc = mysqli_connect('localhost', $C_USERNAME, $C_PASSWORD, $C_DATABASE);
        if (!$dbc) {
          echo ("Something got wrong!");
          echo ("Message: ". mysqli_connect_error()."<br>");
        } else {
          debug_echo("Connect succeeded.<br>");
        }

        $escaped_uri = mysqli_real_escape_string($dbc, trim($_SERVER['PHP_SELF']));
        
        #======================================================================
        # Plain web page counter handling: when page is loaded, increment
        # the counter.
        #======================================================================

        $result = mysqli_query($dbc, "START TRANSACTION");
        report_sql_error(!$result, "START TRANSACTION", "passed", "error");        

        $query = "SELECT counter FROM web_counter_table WHERE url=\"".$escaped_uri."\"";
        $result = mysqli_query($dbc, $query);
        report_sql_error(!$result, $query, "passed", "error");

        $counter_last = 0;
        $num_rows = mysqli_num_rows($result);
        if ((!$result)||($num_rows==0)) {
            $counter_last = 0;
            debug_echo("Counter is initialized.");
            $query = "INSERT INTO web_counter_table (url, counter) VALUES (\"".$escaped_uri."\", 1)";
        } else {
            $row = mysqli_fetch_row($result);
            debug_echo("URL found in the table, counter is advanced.");
            $counter_last = $row[0];
            $query = "UPDATE web_counter_table SET counter = counter + 1 WHERE url=\"".$escaped_uri."\"";
        }

        #Counter is written to the generated web page text:
        echo $counter_last+1;

        $result = mysqli_query($dbc, $query);
        report_sql_error(!$result, $query, "passed", "error");        
        
        $result = mysqli_query($dbc, "COMMIT");
        report_sql_error(!$result, "COMMIT", "passed", "error");          

        #======================================================================
        # Unique users counting
        #======================================================================

        # Compute hash of the IP address
        $user_id = pearsonHash($_SERVER["REMOTE_ADDR"]);

        # Is it in the table from the last five minutes?
        #   - if it is in the hashed_accesses table in the last five minutes 
        #     --> update the time in the table
        #   - if it is not in the hashed_accesses table in the last five minutes
        #     --> add it to the table or update the record which is there,
        #         increase unique visitors's count in the hash record

        $result = mysqli_query($dbc, "START TRANSACTION");
        report_sql_error(!$result, "START TRANSACTION", "passed", "error");              

        $query = "SELECT hash,request_time,visitor_no FROM user_hashes WHERE hash=\"".$user_id."\"";
        $result = mysqli_query($dbc, $query);
        report_sql_error(!$result, $query, "passed", "error");       

        $num_rows = mysqli_num_rows($result);
        if ((!$result)||($num_rows==0)) {
          debug_echo("Hash is not found at all, adding it to the database.");
          $query = "INSERT INTO user_hashes (hash, request_time, visitor_no) VALUES (".$user_id.",".$_SERVER["REQUEST_TIME"].",1)";
        } else {
          debug_echo("Hash is found in the database.");
          $row = mysqli_fetch_row($result);
          if ( ($_SERVER["REQUEST_TIME"]-$row[1]) > $C_VISITOR_TIMEOUT ) {
            #timeout was exceeded, this is a new user
            $query = "UPDATE user_hashes SET visitor_no = visitor_no + 1, request_time = ".$_SERVER["REQUEST_TIME"]." WHERE hash=".$user_id;
          } else {
            #timeout was not exceeded, the same user, we only update the last time of the access
            $query = "UPDATE user_hashes SET request_time = ".$_SERVER["REQUEST_TIME"]." WHERE hash=".$user_id;
          }
        }

        $result = mysqli_query($dbc, $query);
        report_sql_error(!$result, $query, "passed", "error");  

        $result = mysqli_query($dbc, "COMMIT");
        report_sql_error(!$result, "COMMIT", "passed", "error");             

        #======================================================================
        # Web page access tracing - which pages are followed in which sequence
        #======================================================================

        #Insert a new row into the tracing table. Then delete all rows which
        #are older than one month to prevent the table from growing above
        #all the limits.
        
        $result = mysqli_query($dbc, "START TRANSACTION");
        report_sql_error(!$result, "START TRANSACTION", "passed", "error");              

        #insert a new record to the "traces" table - current time, hash, and page address 
        $query = "INSERT INTO traces (hash, request_time, url) VALUES (".$user_id.",".$_SERVER["REQUEST_TIME"].",\"".$escaped_uri."\")";
        $result = mysqli_query($dbc, $query);
        report_sql_error(!$result, $query, "passed", "error");  

        #delete all requests older than defined time
        $delete_time_from = $_SERVER["REQUEST_TIME"] - $C_DELETE_PERIOD;
        $query = "DELETE FROM traces WHERE request_time < ".$delete_time_from;

        $result = mysqli_query($dbc, $query);
        report_sql_error(!$result, $query, "passed", "error");  

        $result = mysqli_query($dbc, "COMMIT");       
        report_sql_error(!$result, "COMMIT", "passed", "error");         

        #----------------------------------------------------------------------
        #All done, close the database
        #----------------------------------------------------------------------        
        mysqli_close($dbc);
        ?>
        </body>
    </html>