﻿<!--
###############################################################################
# The code below is released to public domain, you can do whatever you want
# with it and there is no need to refer to me as the original author.
#
# However, if you find it useful, I will be happy if you let me know :-)!
# Any comments to the code are also welcome. Especially if you find a bug
# or something which can be improved, I will be very happy to hear about it.
# You can contact me at papacut@kosmishmish.com.
#
# The code and the whole package is provided as it is, you acknowledge that it 
# can contain bugs. The author is neither responsible for any damage or loss,
# whether direct, consequential, incidental, or special which user suffers
# arising from any defect, error or fault of the application or its failure to
# perform, even if author has been advised of the possibility of such defect,
# error, fault, or failure. In any event, author's total aggregate liability
# to you for all damages of every kind and type (regardless of whether based in
# contract or tort) shall not exceed $0.00. In the case that applicable law may
# not allow the limitation or exclusion of liability or incidental or
# consequential damages, the above limitation or exclusion may not apply to
# you, although author's liability will be limited to the fullest extent
# permitted by applicable law. 
###############################################################################
-->

<?php
  #This file contains some debugging functions and support

  $debug = false; #if set to true, debug outputs will be allowed

  #debug printing function, prints the string only if debugging mode is on
  function debug_echo($debug_string) {
    global $debug;
    if ($debug) {
      echo "<em>".$debug_string."</em><br>";
    }
  }

  #handling of the database error messages
  #$error_condition: boolean, if true --> error is to be reported
  #$description: generic description of the script operation
  #$success: message indicating the success of the operation
  #$brief_error: short description of the error state
  #
  # If the debug mode is off, brief error is printed in case of an error
  # If the debug mode is on, in case of error the error message is printed
  #   or an indication of success is displayed if all is fine.
  function report_sql_error($error_condition, $description, $success, $brief_error) {
      global $debug;    
      if ($error_condition) {
          if ($debug) {
              printf("<br>%s:%s<br>",$description,mysqli_error());
          } else {
              printf("%s<br>",$brief_error);
          }
      } else {
        debug_echo($description.":".$success);
      }
  }

?>